
MOD = 10**9 + 9

def modexp(a,b,mod):
    if b==0: return 1%mod
    t = modexp(a,b//2,mod)
    return (t * t * (a if b%2 else 1)) % mod

def inv(a,mod): return modexp(a,mod-2,mod)

fact = [1]
for n in range(1,100047): fact.append( (fact[-1]*n)%MOD )
invfact = [ inv(fact[i],MOD) for i in range(100047) ]

from sys import stdin
from re import match

line = stdin.readline()
assert match('^[1-9]\d*\n$',line)
T = int(line)
assert 1 <= T

rest_of_input = stdin.readlines()
assert len(rest_of_input) == 3*T

for t in range(T):
    assert match('^\n$',rest_of_input[3*t])
    assert match('^[1-9]\d*\n$',rest_of_input[3*t+1])
    assert match('^[1-9]\d*( [1-9]\d*)*\n$',rest_of_input[3*t+2])
    
    N = int( rest_of_input[3*t+1] )
    assert 1 <= N <= 10**5

    A = [ int(x)-1 for x in rest_of_input[3*t+2].split() ]
    assert len(A) == N
    assert len(set(A)) == N
    assert 0 <= min(A) and max(A) < N

    cycle_lengths = []
    seen = [ False for _ in range(N) ]
    for n in range(N):
        if not seen[n]:
            kde = n
            current_length = 0
            while True:
                current_length += 1
                seen[kde] = True
                kde = A[kde]
                if kde == n: break
            cycle_lengths.append( current_length )

    answer = 1
    for x in cycle_lengths:
        if x > 1: answer = (answer * modexp(x,x-2,MOD)) % MOD
        answer = (answer * invfact[x-1]) % MOD
    answer = (answer * fact[N-len(cycle_lengths)]) % MOD
    print(answer)

                
